<?php

/**
 * @file
 * Provides functions for Administration settings.
 */
module_load_include('php', 'bulk_image_resizer', '/class.imageresizer');
module_load_include('inc', 'bulk_image_resizer', '/system.archiver');
/**
 * @ingroup forms
 */
function bulk_image_resizer_form($form, &$form_state) {
	
  $form['width'] = array(
    '#type' => 'textfield',
    '#title' => t('Width'),
  );

  $form['height'] = array(
    '#type' => 'textfield',
    '#title' => t('Height'),
  );  
  
  $form['file'] = array(
    '#type' => 'managed_file',
    '#title' => t('Upload File'),
    '#description' => t('Upload a file, allowed extensions: jpg, jpeg, png, gif, zip'),
    '#upload_validators' => array(
      'file_validate_extensions' => array('jpg jpeg png gif zip'),
    ),    
	'#upload_location' => 'public://bulk_image/img'
  );  

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Resize'),
  );
  return $form;
}

/**
 * Form validation handler for clear_custom_cache_form().
 *
 * @ingroup forms
 */
/*function clear_custom_cache_form_validate($form, &$form_state) {
  if (empty($form_state['values']['cid']) && $form_state['values']['cache_bin'] == 'NULL') {
    form_set_error('cid', t('Select Atleat One (cid Or cache_bin)!!'));
  }
}*/

/**
 * Form submission handler for clear_custom_cache_form().
 *
 * @ingroup forms
 */
function bulk_image_resizer_form_submit($form, &$form_state) {
	
  $width = $form_state['values']['width'];
  $height = $form_state['values']['height'];
  
  $file = file_load($form_state['values']['file']);
  $image_name = $file->filename;

  $uri = 'public://bulk_image/img';  
  $path_img = drupal_realpath($uri);

  $dir_thumb = 'public://bulk_image/thumb'; 
  $path_thumb = drupal_realpath($dir_thumb);
  file_prepare_directory($dir_thumb, FILE_CREATE_DIRECTORY); 

  $file_mime_zip = $file->filemime; 
  
  if($file_mime_zip == 'application/zip'){
		$extractor = new Extractor;
		// Path of archive file
		$archivePath = $path_img. '/' .$image_name;
		// Destination path
		$destPath = $path_img;
		// Extract archive file
		$extract = $extractor->extract($archivePath, $destPath);
		if($extract){
			echo $GLOBALS['status']['success'];
		}else{
			echo $GLOBALS['status']['error'];
		}
		$zip_file_explode = explode('.',$file->filename);
	    $zip_filename = $zip_file_explode[0];
	    $zip_file_path = $path_img.'/'.$zip_filename;
	    chmod($zip_file_path,0777);
	    $args = array(
			'path'      => $zip_file_path,
			'img_dir'	=> $zip_file_path,
			'thumb_dir' => $path_thumb,
			'height'    => $width,
			'width'     => $height
		);
		$img = new ImageResizer($args);
		$img->create();
		delete_files($zip_file_path);
  }else{
  // Create thumbnails
	$args = array(
		'path'      => $path_img,
	    'img_dir'	=> $path_img,
	    'thumb_dir' => $path_thumb,
		'height'    => $width,
		'width'     => $height
	);
	$img = new ImageResizer($args);
	$img->create();
	deleteAllFiles($path_img);
  }
	//$img = new ImageResizer($args);
	//$img->create();	
	//call our function	
	//deleteAllFiles($path_img);
	drupal_set_message(t('Images stored on :- '. $path_thumb));
		//delete_files(is_dir($zip_file_path));
}

function deleteAllFiles($str) {
    //It it's a file.
    if (is_file($str)) {
        //Attempt to delete it.
        return unlink($str);
    }
    //If it's a directory.
    elseif (is_dir($str)) {
        //Get a list of the files in this directory.
        $scan = glob(rtrim($str,'/').'/*');
        //Loop through the list of files.
        foreach($scan as $index=>$path) {
            //Call our recursive function.
            unlink($path);
        }
    }
}

function delete_files($target) {
    if(is_dir($target)){
        $files = glob( $target . '*', GLOB_MARK ); //GLOB_MARK adds a slash to directories returned

        foreach( $files as $file ){
            delete_files( $file );      
        }

        rmdir( $target );
    } elseif(is_file($target)) {
        unlink( $target );  
    }
}
